/* $Header: /cvsroot/dhcp-agent/dhcp-agent/src/dhcp-server-states.c,v 1.3 2003/07/15 10:57:55 actmodern Exp $
 * 
 * Copyright 2002 Thamer Alharbash <tmh@whitefang.com>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 3. The names of the authors may not be used to endorse or promote
 * products derived from this software without specific prior
 * written permission.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * These are the individual server state functions, 
 * along with their utility routines.
 * 
 */

#define MODULE_NAME "dhcp-server-states"

#include "dhcp-local.h"
#include "dhcp-limits.h"
#include "dhcp-libutil.h"
#include "dhcp-librawnet.h"

#include "dhcp-server-conf.h"
#include "dhcp-server.h"


/*******************************
 * event processing routines.  *
 *******************************/
 
static int server_next_event(dhcp_server_control_t *sc)
{
    
    return 0;
}

/***************************
 * server states           *
 ***************************/

/* server wait: this is the main server loop.
 *
 * We call server_next_event() and we 
 * receive one of the following events back.
 *
 * (1) SERVER_EVENT_LEASE_EXPIRE
 * (2) SERVER_EVENT_DATA_WAITING
 *
 */

int server_wait(dhcp_server_control_t *sc)
{
    server_next_event(sc);
    return STATE_SHUTDOWN;
}

int server_shutdown(dhcp_server_control_t *sc)
{
    if(sc) { /* only cleanup if we can. */
        
        INFO_MESSAGE("shutting down");

        /* delete the PID file. */
        file_delete_pid(sc->interface);

    }

    exit(0);
}

